// ************************************************************************************************
// SOUS-PROGRAMMES
// http://www.cplusplus.com/reference/  Aide en C/C++
// ************************************************************************************************
/* Programme au -ieme de seconde, gestion des temporisations
 NB : le débordement du compteur en (unsigned long) a lieu tous les 50 jours environ ...
 lorsqu'il arrive à la valeur 2^32-1 = 4294967295 = 49j 17h 2m 47s
 F1FWG : je ne sais ce qui se passe dans ces cas-là ...
 delta devient négatif, euh non, très grand : 
 previousMillis = 4294967290
 millis() = 4294967290 + 10(par exemple) = 4294967300 (-4294967296)=> 4 
 delta = 4 - 4294967290 = ??? 
*/
void ger_top_centieme (){
  unsigned long delta;
  unsigned long currentMillis = millis();

// Top Millième de secondes
  delta = currentMillis - previous1;
  if (delta >= 1) {
    milliseconde += delta;
// save the last time you come here
    previous1 = currentMillis;   
    top_1 = delta;
  }

// Top Centième de secondes
  delta = currentMillis - previous10;
  if (delta >= 10) {
// save the last time you come here
    previous10 = currentMillis;   
    top_10 = delta;
  }

// Top Dixième de seconde
   delta = currentMillis - previous100;
   if (delta >= 100) {
    previous100 = currentMillis;   
    top_100ms = true;
    
// Top Seconde
    if (second() != previousSecond) {
      previousSecond = second();
      top_1000ms = true;
      milliseconde = 0;

// Top Minute
      if (previousSecond == 0) top_60000ms=true;
    }
  }

// Top 250ms
   delta = currentMillis - previous250;
   if (delta >= 250) {
    previous250 = currentMillis;   
    top_250ms = true;

// Top 500ms
     delta = currentMillis - previous500;
     if (delta >= 500) {
       previous500 = currentMillis;   
       top_500ms = true;
     }
   }
  return;
}
// ************************************************************************************************
// affichage horloge sur la sortie serie, sans fin de ligne
void horodatage_serial() {
// heure seulement
  Serial << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << " ";
// date et heure
//  Serial << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year() << " " << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << " ";
}

// affichage horloge sur la sortie serie, sans fin de ligne
void horodatage_serie(char format) {
// 15:28.584
  if (format == 'c') Serial << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << "." << ((milliseconde<10)?"00":(milliseconde<100)?"0":"") << milliseconde << " ";
// 10:15:28
  if (format == 'h') Serial << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << " ";
// 'd' = 01/04/2013 10:15:28
  if (format == 'd') Serial << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year() << " " << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << " ";
}
// ************************************************************************************************
/* scrutation et filtrage de clavier analogique

  utilisation "monocoup" :
  if (touche == '1') { ...; touche=' ';}

  utilisation avec "répétition" :
  if (touche_repeat == '1') { ...; touche_repeat=' ';}
*/

void ger_scrute_clavier(){
// clavier - filtrage sur NO de touche (c'est plus stable que sur valeur)
  ntouche6 = ntouche5;
  ntouche5 = ntouche4;
  ntouche4 = ntouche3;
  ntouche3 = ntouche2;
  ntouche2 = ntouche1;
  ntouche1 = ntouche;

  itouche = analogRead(clavier);

    ntouche=-1;
    do {
      ntouche++;
    } while (itouche > ((xtouche[ntouche]+xtouche[ntouche+1])/2) && ntouche < nbtouche);
// OU en appliquant la formule n = ( valeur_ana + 20 ) / 41 on devrait récupérer le No de la touche de 0 à 9 ...

// TRACE pour calibrage
//  if (itouche < 1000 ) Serial << itouche << "=" << ntouche << endl;

// si la touche est stable (X tours)
  if (ntouche==ntouche1 && ntouche==ntouche2 && ntouche==ntouche3 && ntouche==ntouche4 && ntouche==ntouche5 && ntouche==ntouche6) {

// si la touche a varié
    if (ltouche[ntouche] != vtouche ) {
//    if (itouche < 1000 ) Serial << itouche << "=" << ntouche << endl;
      vtouche = ltouche[ntouche];
// touche valide
      if (ntouche < nbtouche) { 
        touche = vtouche;
        touche_repeat = vtouche;
        tempo_repeat=800;  // duree avant repetition
// arret répétition
      } else {
        touche_repeat = ' ';
      }
// si la touche est la même : repeat ?
    } else {
      if (ntouche < nbtouche && tempo_repeat == 0 ) {
        touche_repeat = vtouche;
        tempo_repeat=500;  // vitesse repetition
      }
    }
// debug
//  } else {
//  Serial << itouche6 << " " << itouche5 << " " << itouche4 << " " << itouche3 << " " << itouche2 << " " << itouche1 << " " << itouche << endl;
  }
  return;
}

// ************************************************************************************************

/*
Convertit  la valeur 'float' "v" avec "nbchiffres" digits significatifs suivi de l'"unite"
Donc "nbchiffres" digits + point + multiplicateur + unite = "nbchiffres+3" caractères
Résultat dans 'buf'.
Usage :
char valuef[15];
    freq=123456.789;    formatf(freq,'c',5,valuef); // valuef="123.45Kc\0"
    freq=1.23456789;    formatf(freq,'c',8,valuef); // valuef="1.2345678c \0"
    Serial << "F=" << valuef;                       // sur voie série
    lcd.setCursor(0, 0);  lcd << "F=" << valuef;    // sur LCD
    strcpy(cw_texte,valuef);                        // en MORSE
*/
void formatf(float v,char unite,int nbchiffres,char buf[15])
{
//      dtostrf(floatVar, minStringWidthIncDecimalPoint, numVarsAfterDecimal, charBuf);

 float vloc;
 int mult=5,nbdec;
//   mult =            0    1    2    3    4    5   6     7     8    9
//   multiplicateur =  Peta Tera Giga Mega Kilo 1   milli micro nano pico
 char multiple[10] = {'P', 'T', 'G', 'M', 'k', ' ','m',  'u',  'n', 'p'};
  vloc=v;
// si valeur inférieure à 1, on multiplie
  while (vloc < 1. && mult < 9) {
     vloc = vloc*1000;
     mult++;
   }
// si valeur grande, on divise
   while (vloc >= 1000. && mult > 0) {
     vloc = vloc/1000;
     mult--;
   }
// nombre de décimales selon valeur   // ex nbchiifres=4    7
   nbdec = nbchiffres-3;              //           999.9  999.9999
   if (vloc < 100 ) nbdec++;          //           99.99  99.99999
   if (vloc < 10 ) nbdec++;           //           9.999  9.999999
// conversion FLOAT CHAR
   dtostrf(vloc,nbchiffres,nbdec,buf);
// ici, nbdec devient la longueur obtenue (rien à voir avec le nombre de décimales)
   nbdec=strlen(buf);
   if (mult!=5) {
      buf[nbdec]=multiple[mult]; buf[nbdec+1]=unite;
   } else {
      buf[nbdec]=unite; buf[nbdec+1]=multiple[mult];
   }
// fin de CHAR
   buf[nbdec+2]='\0';
//   Serial << "*buf=" << buf << "*l=" << strlen(buf) << "*" << endl;
   return;
}
// ************************************************************************************************
// traitement de reception sur le port Serial
// synchro de l'hoorloge :
void misealheure() {
  int hmsdmy[6];
  char c;
// pour messages MUSIQUE ou MORSE ou AUTRES
  char msg[30]; 
/*
if (Serial.available() == 1 ){
      c = Serial.read(); 
      Serial << "lu " << c << endl;  
      if (c == '?') {       
         Serial << "ARDUINO present" << endl;  
      }
  }
*/
// if time sync available from serial port, update time and return true
// message = T12,34,56,01,01,13         Thh,mm,ss,dd,mm,yy
//   if (Serial.available() == 18 ){  // time message consists of header & 6 values
      c = Serial.read(); 
      if (c == 'T') {       
          time_t pctime = 0;
          for(int i=0; i < 6; i++){   
            hmsdmy[i]=Serial.parseInt();
          }
          hmsdmy[0] = constrain(hmsdmy[0], 0, 23);
          hmsdmy[1] = constrain(hmsdmy[1], 0, 59);
          hmsdmy[2] = constrain(hmsdmy[2], 0, 59);
          hmsdmy[3] = constrain(hmsdmy[3], 1, 31);
          hmsdmy[4] = constrain(hmsdmy[4], 1, 12);
          setTime(hmsdmy[0],hmsdmy[1],hmsdmy[2],hmsdmy[3],hmsdmy[4],hmsdmy[5]); 
          horodatage_serial(); Serial << "ARDUINO T" << endl;  
       }
//    }      

// Simple test de présence
      if (c == '?') {       
         Serial << "ARDUINO " << version << endl;  
      }

// message = M................
      if (c == 'M') {       
        memset (msg,'\0',30); // RAZ  du buffer
        int j=Serial.available();
        for(int i=0; i < min(j,30); i++) {  
          msg[i]= Serial.read();
        }
// envoi à CW
        if (grafcet_cw == 1) {
          if (debug >0) { horodatage_serial(); Serial << "ARDUINO Music|cw=" << msg << endl; }
          strncpy(cw_texte,msg,30);
        }
      }

// message = X0/X1 AUTORISATION DE TRANSMISSION
      if (c == 'X') {       
        c= Serial.read();
        if (grafcet_cw == 1) {
          if (debug >0) { horodatage_serial(); Serial << "ARDUINO Xmit=" << c << endl; }
//          if (c=='0') { TX_autorisation=0; strcpy(cw_texte,"gec"); }
//          if (c=='1') { TX_autorisation=1; strcpy(cw_texte,"ceg"); }
        }
      }

// message = D0/D1/D2...  DEBUG
      if (c == 'D') {       
        c= Serial.read();
        if (grafcet_cw == 1) {
          if (c >='0' && c <='9') { debug=c-'0'; strcpy(cw_texte,"abcc"); }
          horodatage_serial(); Serial << "ARDUINO Debug=" << debug << endl;
        }
      }
//  }    

}
// T1262347200  //noon Jan 1 2010  ( secondes depuis le 01/01/1970
//  1261440000 sec/40 ans (le décalage donne 10 jours, soit bien 10 années bissextiles)
//       86400 sec/jour
//    31536000 sec/an
// T1293969600  //noon Jan 1 2011
// T1325505600  //noon Jan 1 2012
// T1357041600  //noon Jan 1 2013
// T1388577600  //noon Jan 1 2014 
// ************************************************************************************************
/*
Convertit la valeur 'float' "v" avec "nbchiffres" digits significatifs suivi de l'"unite"
Donc "nbchiffres" caractères
Résultat dans 'buf'.
Usage :
char valuef[15];
    freq=123456.789;    formati(freq,'c',6,valuef); // valuef="123456\0"
    freq=12.3456789;    formati(freq,'c',8,valuef); // valuef="       12\0"
    Serial << "F=" << valuef;                       // sur voie série
    lcd.setCursor(0, 0);  lcd << "F=" << valuef;    // sur LCD
    strcpy(cw_texte,valuef);                        // en MORSE
*/
/*
void formati(int v,int nbchiffres,char buf[15])
{
//      dtostrf(floatVar, minStringWidthIncDecimalPoint, numVarsAfterDecimal, charBuf);

 float vloc;
  vloc=v;
   if (vloc < pow(10,nbchiffres)) nbdec++;          //           99.99  99.99999
   if (vloc < 10 ) nbdec++;          //           9.999  9.999999
// convesrion FLOAT CHAR
   dtostrf(vloc,nbchiffres,nbdec,buf);
// ici, nbdec devient la longueur obtenue (rien à voir avec le nombre de décimales)
   nbdec=strlen(buf);
   if (mult!=5) {
     buf[nbdec+1]=unite; buf[nbdec]=multiple[mult];
   } else {
     buf[nbdec]=unite; buf[nbdec+1]=multiple[mult];
   }
// fin de CHAR
   buf[nbdec+2]='\0';
//   Serial << "*buf=" << buf << "*l=" << strlen(buf) << "*" << endl;
   return;
}
*/
// ************************************************************************************************
// ************************************************************************************************
// ARCHIVES, NOTES ...
// ************************************************************************************************
/*
// AUTRES CONVERSIONS
char* dtostrf  ( double  __val,  
  signed char  __width,  
  unsigned char  __prec,  
  char *  __s  
 ) 
 
 char* itoa  ( int  __val,  
  char *  __s,  
  int  __radix  
 ) 

char* ltoa  ( long int  __val,  
  char *  __s,  
  int  __radix  
 ) 

dtostrf(vloc,nbchiffres,nbdec,cw_texte);
   nbdec=strlen(cw_texte);
   cw_texte[nbdec]=multiple[mult];
   cw_texte[nbdec+1]=unite;
   cw_texte[nbdec+2]='\0';
   }
*/
/*
// Transforme la date et l'heure "lisible" en format UNIX pour mise à l'heure et date
time_t setupArduinoTime(int y,int m, int j, int h, int mi, int se) {
  tmElements_t tm;
  tm.Year = y-1970;
  tm.Month = m;
  tm.Day = j;
  tm.Hour = h;
  tm.Minute = mi;
  tm.Second = se;
  time_t time = makeTime(tm);
  return time;
}
//+ voici le s/p original qui provient d'une bibliothèque pour GPS :
time_t gpsTimeToArduinoTime(){
// returns time_t from gps date and time with the given offset hours
  tmElements_t tm;
  int year;
  gps.crack_datetime(&year, &tm.Month, &tm.Day, &tm.Hour, &tm.Minute, &tm.Second, NULL, NULL);
  time_t time = makeTime(tm);
  return time + (offset * SECS_PER_HOUR);
}
*/
// ************************************************************************************************
// ************************************************************************************************

